package org.starter.learning.service.impl;

import org.springframework.beans.factory.DisposableBean;
import org.springframework.beans.factory.InitializingBean;
import org.starter.learning.dao.BookDao;
import org.starter.learning.dao.impl.BookDaoImpl;
import org.starter.learning.pojo.Book;
import org.starter.learning.service.BookService;

import java.util.List;

public class BookServiceImpl implements BookService, InitializingBean, DisposableBean {
    private BookDao bookDao;
    public BookServiceImpl() {
        System.out.println("BookService object created!");
    }
    @Override
    public List<Book> listBook() {
        return bookDao.getBooks();
    }

    // 提供的对应的Setter方法
//    public void setBookDao(BookDao bookDao) {
//        System.out.println("Setting bookDao into BookService Implement...");
//        this.bookDao = bookDao;
//    }


    public BookServiceImpl(BookDao bookDao) {
        this.bookDao = bookDao;
    }

    // 对象创建后执行的方法 -- 初始化
    @Override
    public void afterPropertiesSet() throws Exception {
        System.out.println("BookService Initializing...");
    }

    // 对象销毁前执行的方法 -- 销毁
    @Override
    public void destroy() throws Exception {
        System.out.println("BookService will be destroy.");
    }
}
